import { Grid } from "@mui/material";
import { memo, useEffect, useState } from "react";
import DefaultTask from "../DefaultTask/DefaultTask";




const CalendarStandartCell = ({ children, xs, hours, dayNumber, createTaskInCellHandler, handleOpen, modal, dragTaskHandler, linesInDay, week, copyTask, createCopyTask, month , year}) => {
    const [isThisCell, setIsThisCell] = useState(false)

    const cellClass = {
        position: 'relative',
        height: linesInDay?.length ? `${45 * linesInDay.length}px` : `${40}px`,
        borderRight: '1px solid black',
        borderBottom: week ? '1px solid black' : null,
        '&:hover': {
            cursor: 'pointer',
            background: children ? null :'#d6d2d2'
        },
    }

    useEffect(() => {
        if (!modal) {
            setIsThisCell(false);
        }
    }, [modal])

    const dragOverHandler = (e) => {
        e.preventDefault();
    }

    const dropHandler = (e) => {
        e.stopPropagation()
        e.preventDefault();
        console.log(dayNumber, parseInt(hours.split(':')[0]))
        dragTaskHandler(dayNumber, parseInt(hours.split(':')[0]), month, year)
    }

    const onClickHandler = (e) => {
        if (copyTask) {
            createCopyTask(dayNumber, parseInt(hours.split(':')[0]), month, year)
        } else {
            createTaskInCellHandler(dayNumber, hours, month, year);
            setIsThisCell(true);
            handleOpen(e)
        }
    }

    return <>
        <Grid
            item xs={xs}
            sx={cellClass}
            onClick={(e) => { onClickHandler(e) }}
            onDragOver={(e) => { dragOverHandler(e) }}
            onDrop={(e) => { dropHandler(e) }}
        >
            {children}
            {isThisCell ?
                <DefaultTask week={week} /> : null}

        </Grid>
    </>
};

export default memo(CalendarStandartCell, (prevProps, nextProps) => {
    if (!prevProps.modal) return false
    if (nextProps.modal) return true
});